; priv_str.asm Show use of WritePrivateProfileString
;              Check a value in win1.ini  Help from Bartosz Wjcik,P1,Light-I,
;              Use of extended ASCII characters in strings

.486                       
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive

    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc
    include \masm32\macros\macros.asm

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib   
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\oleaut32.lib

.data 
      sec      BYTE    "Wieviel",0          ; [Section]
      key      BYTE    "Nummer",0          ; Nummer=0E9h,0EAh                         
      value    BYTE    0E9h,0EAh,00h            ; Alt 233,234 0E9h 0EAh
      file     BYTE    "c:\masm32\source\win1.ini",0 ; path of filename
      value1OK BYTE    "1st value OK.",0  
      value2OK BYTE    "2nd value OK.",0  
      Sample   BYTE    "Box",0
      StrBuf   BYTE    4 dup(0)
      
.code

start:
  
fn WritePrivateProfileString, Offset sec, ADDR key, ADDR value, ADDR file

 ; returns only number of characters in string
 ;   |
fn GetPrivateProfileString,Offset sec,ADDR key,0,ADDR StrBuf,SIZEOF StrBuf,ADDR file

;lea ebx, StrBuf  ; look at character in buffer
;movzx eax, BYTE PTR [ebx]

lea esi, StrBuf[0]   ;look at 1st character in buffer to see if a match
lodsb

.if EAX==0E9h 
invoke MessageBox, 0, ADDR value1OK, ADDR Sample,MB_ICONINFORMATION
.endif

lea esi, StrBuf[1]   ;look at 2nd character in buffer to see if a match
lodsb

.if EAX==0EAh 
invoke MessageBox, 0, ADDR value2OK, ADDR Sample,MB_ICONINFORMATION
.endif

invoke ExitProcess,0

end start

